.model tiny
.code
.386

sysseg equ 100h;5000h
dopseg equ 200h;7000h

org 7c00h
         jmp boot
         db 'EOS  1.0'
bytesec: dw 200h
secclas: db 01h
ressec:  dw 01h
numfat:  db 02h
recroot: dw 00e0h
numsec:  dw 0b40h
id_drv:  db 0f0h
secfat:  dw 0009h
sectrk:  dw 0012h
numhead: dw 0002h
hidesec: dw 0000

boot:    ;Dl = drive    load = 07c0:0000
         cli   ;        han =  0800:0000
         mov ax,cs
         mov ds,ax
         mov ss,ax
         xor sp,sp
         mov ax,dopseg
         mov fs,ax
         sti
         mov byte ptr drive,dl
         cmp byte ptr id_drv,0f8h
         jne m5
         mov byte ptr fattype,2
m5:
         mov ax,word ptr recroot
         mov cl,4
         shr ax,cl
         mov dx,word ptr secfat
         shl dx,1
         add ax,dx
         inc ax
         mov word ptr dataofs,ax
reboot:
        call findfile
        jc m1
        call fileread
jamp:   db 0eah
        dw 0000h
        dw sysseg

m1:     lea si,msg
        cld
p1:     lodsb                   ;AL=DS:[SI]
        cmp al,0
        je p2
        mov ah,0eh
        mov bx,0007h
        int 10h
        jmp p1
p2:
        xor ah,ah
        int 16h
        jmp reboot

;-----------------------------------------------------------------------------
;    CX = ⢮ ᥪ஢
;    EDX = ᫥⥫  ᥪ
;    ES:BX =   뢠
secread:
        mov di,bx
        mov si,cx
        mov dword ptr h25lsec,edx
h4:
        mov ax,word ptr h25lsec
        mov dx,word ptr h25lsec+2
        mov bx,word ptr sectrk
        div bx
        inc dx
        mov byte ptr h25sector,dl;sector=DX

        mov bx,word ptr numhead
        xor dx,dx
        div bx
        mov byte ptr h25head,dl;head=DX

        mov ax,word ptr sectrk
        mov bx,word ptr numhead
        mul bx
        mov bx,ax
        ;DX:AX - DX  뢠
        mov ax,word ptr h25lsec
        mov dx,word ptr h25lsec+2
        div bx
                                  ;cylinder=ax
        mov cx,ax
        shl ch,6
        xchg cl,ch
        add cl,byte ptr h25sector

        mov dl,byte ptr drive
        mov dh,byte ptr h25head
        mov bx,di
        mov ax,0201h
        int 13h
        jnc h5
        ret

h5:     dec si
        jz h6
        inc dword ptr h25lsec

        mov dx,es
        add dx,32
        mov es,dx

        jmp h4

h6:     ret
;-------------------------------
clasFAT:                ;AX =    ᪠ ᫥饣
       push fs
       pop es
       cmp byte ptr FATtype,1      ;FAT12
       je clasFAT12

clasFAT16:              ;AX =    ᪠ ᫥饣
       shl ax,1    ;AX*2

       mov bx,512
       xor dx,dx
       div bx     ;AX/BX
       push dx

       movzx edx,ax
       inc dx;add dx,cs:word ptr fat1ofs
       xor bx,bx
       mov cx,1
       call secread

       pop bx
       mov ax,fs:word ptr [bx]
       ret                 ;AX - ᫥饣

clasFAT12:                 ;AX =    ᪠ ᫥饣
    push ax
    mov bx,3    ;AX*3
    mul bx
    shr ax,1    ;AX/2

    ;if not exist_in_dop
    mov bx,512
    xor dx,dx
    div bx     ;AX/BX
    push dx

    movzx edx,ax
    inc dx;add dx,cs:word ptr fat1ofs
    mov cx,2
    xor bx,bx
    call secread

    pop bx
    mov ax,fs:word ptr [bx]
    pop bx
    bt bx,0
    jc p14
    and ah,00001111b
    jmp p15
p14:
    mov cl,4
    shr ax,cl
p15:
    ret                 ;AX - ᫥饣


;------------------------------
fileread:
        mov ax,word ptr addr
        mov bp,sysseg    ;Segment of system file
m4:
        movzx bx,byte ptr secclas    ;AX=claster;
        mul bx                                  ;
        mov cl,8                                ;
        shl edx,cl                              ;
        mov dx,ax                               ;  CLASTOSECT
        movzx eax,word ptr dataofs              ;
        dec eax                                 ;
        dec eax                                 ;
        add edx,eax                 ;EDX=lsector;

        mov cx,1
        xor bx,bx
        mov es,bp
        call secread

        mov ax,word ptr addr
        call clasfat
        mov word ptr addr,ax

        cmp byte ptr FATtype,1      ;FAT12
        je c12

c16:    cmp ax,0fff8h
        jge m3
        jmp m8
c12:    cmp ax,0ff8h
        jge m3
m8:
        add bp,32
        jmp m4
m3:
        ret

;-------------------------------
findfile:
    mov ax,word ptr recroot
    mov cl,4
    shr ax,cl ; AX*32/512
    mov cx,ax ; ⢮ ᥪ஢

    mov ax,word ptr secfat
    mov dl,byte ptr numfat
    mul dl
    inc ax    ; Root offset

    movzx edx,ax
    push fs
    pop es
    push es
    xor bx,bx
    call secread
    pop es

    mov cx,word ptr recroot
    xor bx,bx
n3:
    mov di,bx
    lea si,sfn
    mov dx,11

n2: cmpsb
    jne n1
    dec dx
    jnz n2
        ;ok
    mov ax,es:[bx+1ah]
    mov word ptr addr,ax
    clc
    ret

n1:
    add bx,32
    loop n3
           ;nofile
    stc
    ret

;-----------------------------------------------------------------------------
msg:      db 'System not found',10,13,0
sfn:      db 'BOOT    SYS'

fattype   db 1
addr      dw 0
drive     db 0
dataofs   dw 0
h25sector db 0
h25head   db 0
h25lsec   dd 0

;res     dw 0
         end